*** ../nagios-orig/xdata/xodtemplate.c	Mon Feb 16 20:59:32 2004
--- xdata/xodtemplate.c	Wed Mar 24 19:31:03 2004
***************
*** 6493,6498 ****
--- 6493,6500 ----
  					write_to_logs_and_console(temp_buffer,NSLOG_CONFIG_ERROR,TRUE);
  #endif
  					free(member_names);
+ 					free(host_name);
+ 					free(service_description);
  					return ERROR;
  				        }
  
***************
*** 6527,6540 ****
  				host_name=NULL;
  				service_description=NULL;
  			        }
- 
- 			/* in case there isn't a matching service description... */
- 			free(host_name);
- 			host_name=NULL;
  		        }
  
  		free(member_names);
  	        }
  
  
  	/* process all services that have servicegroup directives */
--- 6529,6549 ----
  				host_name=NULL;
  				service_description=NULL;
  			        }
  		        }
  
  		free(member_names);
+ 
+ 		/* if there were an odd number of items specified (host1,service1,host2) */
+ 		if(host_name!=NULL){
+ #ifdef NSCORE
+ 			snprintf(temp_buffer,sizeof(temp_buffer)-1,"Error: servicegroup members must be specified in host_name,service_description pairs (config file '%s', starting on line %d)\n",xodtemplate_config_file_name(temp_servicegroup->_config_file),temp_servicegroup->_start_line);
+ 			temp_buffer[sizeof(temp_buffer)-1]='\x0';
+ 			write_to_logs_and_console(temp_buffer,NSLOG_CONFIG_ERROR,TRUE);
+ #endif
+ 			free(host_name);
+ 			return ERROR;
  		        }
+ 	        }
  
  
  	/* process all services that have servicegroup directives */
